% plots a representation of a camera given its P matrix
% 
% P 		- 3x4 camera matrix
% color 	- desired color
% size_c 	- desired size of the camera representation

% 2015, Cenek Albl, alblcene@cmp.felk.cvut.cz

function draw_camera(P,color,size_c)
[K,R,C] = dm_KR_from_P(P);
pts_cam = [-1 -1 1; 1 -1 1; 1 1 1; -1 1 1]'*size_c;
pts_world = h2a([R' +C; 0 0 0 1]*a2h(pts_cam));
pts_lines = [pts_world(:,1) pts_world(:,2) pts_world(:,3) pts_world(:,4) C];
pts_idxs = [1 2 2 3 3 4 4 1 1 5 2 5 3 5 4 5];
for i=1:2:size(pts_idxs,2)
    id1=pts_idxs(i);
    id2=pts_idxs(i+1);
    plot3([pts_lines(1,id1) pts_lines(1,id2)],[pts_lines(2,id1) pts_lines(2,id2)],[pts_lines(3,id1) pts_lines(3,id2)],color,'LineWidth',2);
    hold on
end

end

